
#ifndef GRAPHDIALOG_H
#define GRAPHDIALOG_H
/**********************************************************************

  graphdialog.h

  Author    : fuja2 ( fuja2 at bj8 dot so-net dot ne dot jp )
  created at: Fri. MAY.21  23:59:03 JST 2004
  edited  at: 

  Copyright (C) 2004  Kazuo Sonobe, All rights reserved.

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

**********************************************************************/
#include <qlayout.h>
#include <qdialog.h>
#include <qptrlist.h>
#include <qcanvas.h>
#include <qlabel.h>
#include <qslider.h>
#include "asrulelist.h"
#include "soolist.h"
#include "canvas.h"


class QHBoxLayout;
class QPushButton;
//class QTable;
class QVBoxLayout;
//class graphDialog;


//typedef    QPtrList<tableDialog>   tableDPtrList;

class graphDialog: public QDialog
{
    Q_OBJECT
public:
    graphDialog( int,
                 SooListList*, AsRuleSooList* , QWidget* parent );
    //~graphDialog();
    //QStringList  getWordOrgList();
    //bool         getKillFlag() { return killFlag; }

public slots:
    //void  moreInfo();

protected slots:
    void accept();
    //void done( int r );
    
    void  thresChanged();
    void  thresDispS( int value );
    void  thresDispC( int value );
    void  thresDispL( int value );

private:
    //QTable *table_key;
    QPushButton *closeButton;
    //QPushButton *moreButton;
    //tableDPtrList* ptrtableDList;
    //bool        killFlag;
    QCanvas* canvas_graph;
    FigureEditor* editor;

    int keyMax;
    int keyIndex;
    SooListList* tmpSooListList;
    AsRuleSooList* tmpAsList;
    QMemArray<NodeItem*> NodeArray;
    QMemArray<int>       keyArray;
    QMemArray<QPoint>    positionArray;
    QMemArray<int>       positionArrayKey;

    int NodeNum;

protected:
    QGridLayout *WidgetsBaseLayout;
    //QVBoxLayout *tableButtonBox;
    //QWidget     *labelWidget;
    //QHBoxLayout *labelBox;
    QWidget     *canvasWidget;
    QHBoxLayout *canvasBox;
    QWidget     *buttonWidget;
    QHBoxLayout *buttonBox;

    QLabel*      dirLabel;
    QLabel*      dirLabeS;
    QLabel*      dirLabeC;
    QLabel*      dirLabeL;
    
    QSlider* sliderS;
    QSlider* sliderC;
    QSlider* sliderL;
    double Smax , Smin;
    double Cmax , Cmin;
    double Lmax , Lmin;


private:
    //SooList soolist;
};

#endif
